


<!DOCTYPE html>
<html>
<head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
    
    
    <meta http-equiv="X-UA-Compatible" content="IE=emulateIE7" />
    <title>Coverage for /private/tmp/im/impacket/impacket/dhcp.py: 32%</title>
    <link rel="stylesheet" href="style.css" type="text/css">
    
    <script type="text/javascript" src="jquery.min.js"></script>
    <script type="text/javascript" src="jquery.hotkeys.js"></script>
    <script type="text/javascript" src="jquery.isonscreen.js"></script>
    <script type="text/javascript" src="coverage_html.js"></script>
    <script type="text/javascript">
        jQuery(document).ready(coverage.pyfile_ready);
    </script>
</head>
<body class="pyfile">

<div id="header">
    <div class="content">
        <h1>Coverage for <b>/private/tmp/im/impacket/impacket/dhcp.py</b> :
            <span class="pc_cov">32%</span>
        </h1>

        <img id="keyboard_icon" src="keybd_closed.png" alt="Show keyboard shortcuts" />

        <h2 class="stats">
            58 statements &nbsp;
            <span class="run hide_run shortkey_r button_toggle_run">26 run</span>
            <span class="mis shortkey_m button_toggle_mis">32 missing</span>
            <span class="exc shortkey_x button_toggle_exc">0 excluded</span>

            
                <span class="par run hide_run shortkey_p button_toggle_par">0 partial</span>
            
        </h2>
    </div>
</div>

<div class="help_panel">
    <img id="panel_icon" src="keybd_open.png" alt="Hide keyboard shortcuts" />
    <p class="legend">Hot-keys on this page</p>
    <div>
    <p class="keyhelp">
        <span class="key">r</span>
        <span class="key">m</span>
        <span class="key">x</span>
        <span class="key">p</span> &nbsp; toggle line displays
    </p>
    <p class="keyhelp">
        <span class="key">j</span>
        <span class="key">k</span> &nbsp; next/prev highlighted chunk
    </p>
    <p class="keyhelp">
        <span class="key">0</span> &nbsp; (zero) top of page
    </p>
    <p class="keyhelp">
        <span class="key">1</span> &nbsp; (one) first highlighted chunk
    </p>
    </div>
</div>

<div id="source">
    <table>
        <tr>
            <td class="linenos">
<p id="n1" class="pln"><a href="#n1">1</a></p>
<p id="n2" class="pln"><a href="#n2">2</a></p>
<p id="n3" class="pln"><a href="#n3">3</a></p>
<p id="n4" class="pln"><a href="#n4">4</a></p>
<p id="n5" class="pln"><a href="#n5">5</a></p>
<p id="n6" class="pln"><a href="#n6">6</a></p>
<p id="n7" class="pln"><a href="#n7">7</a></p>
<p id="n8" class="stm run hide_run"><a href="#n8">8</a></p>
<p id="n9" class="stm run hide_run"><a href="#n9">9</a></p>
<p id="n10" class="pln"><a href="#n10">10</a></p>
<p id="n11" class="stm run hide_run"><a href="#n11">11</a></p>
<p id="n12" class="stm run hide_run"><a href="#n12">12</a></p>
<p id="n13" class="pln"><a href="#n13">13</a></p>
<p id="n14" class="pln"><a href="#n14">14</a></p>
<p id="n15" class="pln"><a href="#n15">15</a></p>
<p id="n16" class="pln"><a href="#n16">16</a></p>
<p id="n17" class="pln"><a href="#n17">17</a></p>
<p id="n18" class="pln"><a href="#n18">18</a></p>
<p id="n19" class="pln"><a href="#n19">19</a></p>
<p id="n20" class="pln"><a href="#n20">20</a></p>
<p id="n21" class="pln"><a href="#n21">21</a></p>
<p id="n22" class="pln"><a href="#n22">22</a></p>
<p id="n23" class="pln"><a href="#n23">23</a></p>
<p id="n24" class="pln"><a href="#n24">24</a></p>
<p id="n25" class="pln"><a href="#n25">25</a></p>
<p id="n26" class="pln"><a href="#n26">26</a></p>
<p id="n27" class="pln"><a href="#n27">27</a></p>
<p id="n28" class="pln"><a href="#n28">28</a></p>
<p id="n29" class="stm run hide_run"><a href="#n29">29</a></p>
<p id="n30" class="stm mis"><a href="#n30">30</a></p>
<p id="n31" class="pln"><a href="#n31">31</a></p>
<p id="n32" class="stm run hide_run"><a href="#n32">32</a></p>
<p id="n33" class="pln"><a href="#n33">33</a></p>
<p id="n34" class="pln"><a href="#n34">34</a></p>
<p id="n35" class="pln"><a href="#n35">35</a></p>
<p id="n36" class="stm run hide_run"><a href="#n36">36</a></p>
<p id="n37" class="stm run hide_run"><a href="#n37">37</a></p>
<p id="n38" class="stm run hide_run"><a href="#n38">38</a></p>
<p id="n39" class="pln"><a href="#n39">39</a></p>
<p id="n40" class="stm run hide_run"><a href="#n40">40</a></p>
<p id="n41" class="stm run hide_run"><a href="#n41">41</a></p>
<p id="n42" class="stm run hide_run"><a href="#n42">42</a></p>
<p id="n43" class="stm run hide_run"><a href="#n43">43</a></p>
<p id="n44" class="stm run hide_run"><a href="#n44">44</a></p>
<p id="n45" class="stm run hide_run"><a href="#n45">45</a></p>
<p id="n46" class="stm run hide_run"><a href="#n46">46</a></p>
<p id="n47" class="stm run hide_run"><a href="#n47">47</a></p>
<p id="n48" class="pln"><a href="#n48">48</a></p>
<p id="n49" class="stm run hide_run"><a href="#n49">49</a></p>
<p id="n50" class="pln"><a href="#n50">50</a></p>
<p id="n51" class="pln"><a href="#n51">51</a></p>
<p id="n52" class="pln"><a href="#n52">52</a></p>
<p id="n53" class="pln"><a href="#n53">53</a></p>
<p id="n54" class="pln"><a href="#n54">54</a></p>
<p id="n55" class="pln"><a href="#n55">55</a></p>
<p id="n56" class="pln"><a href="#n56">56</a></p>
<p id="n57" class="pln"><a href="#n57">57</a></p>
<p id="n58" class="pln"><a href="#n58">58</a></p>
<p id="n59" class="pln"><a href="#n59">59</a></p>
<p id="n60" class="pln"><a href="#n60">60</a></p>
<p id="n61" class="pln"><a href="#n61">61</a></p>
<p id="n62" class="pln"><a href="#n62">62</a></p>
<p id="n63" class="pln"><a href="#n63">63</a></p>
<p id="n64" class="pln"><a href="#n64">64</a></p>
<p id="n65" class="pln"><a href="#n65">65</a></p>
<p id="n66" class="pln"><a href="#n66">66</a></p>
<p id="n67" class="pln"><a href="#n67">67</a></p>
<p id="n68" class="pln"><a href="#n68">68</a></p>
<p id="n69" class="pln"><a href="#n69">69</a></p>
<p id="n70" class="pln"><a href="#n70">70</a></p>
<p id="n71" class="pln"><a href="#n71">71</a></p>
<p id="n72" class="pln"><a href="#n72">72</a></p>
<p id="n73" class="pln"><a href="#n73">73</a></p>
<p id="n74" class="pln"><a href="#n74">74</a></p>
<p id="n75" class="pln"><a href="#n75">75</a></p>
<p id="n76" class="pln"><a href="#n76">76</a></p>
<p id="n77" class="pln"><a href="#n77">77</a></p>
<p id="n78" class="pln"><a href="#n78">78</a></p>
<p id="n79" class="pln"><a href="#n79">79</a></p>
<p id="n80" class="pln"><a href="#n80">80</a></p>
<p id="n81" class="pln"><a href="#n81">81</a></p>
<p id="n82" class="pln"><a href="#n82">82</a></p>
<p id="n83" class="pln"><a href="#n83">83</a></p>
<p id="n84" class="pln"><a href="#n84">84</a></p>
<p id="n85" class="pln"><a href="#n85">85</a></p>
<p id="n86" class="pln"><a href="#n86">86</a></p>
<p id="n87" class="pln"><a href="#n87">87</a></p>
<p id="n88" class="pln"><a href="#n88">88</a></p>
<p id="n89" class="pln"><a href="#n89">89</a></p>
<p id="n90" class="pln"><a href="#n90">90</a></p>
<p id="n91" class="pln"><a href="#n91">91</a></p>
<p id="n92" class="pln"><a href="#n92">92</a></p>
<p id="n93" class="pln"><a href="#n93">93</a></p>
<p id="n94" class="pln"><a href="#n94">94</a></p>
<p id="n95" class="pln"><a href="#n95">95</a></p>
<p id="n96" class="pln"><a href="#n96">96</a></p>
<p id="n97" class="pln"><a href="#n97">97</a></p>
<p id="n98" class="pln"><a href="#n98">98</a></p>
<p id="n99" class="pln"><a href="#n99">99</a></p>
<p id="n100" class="pln"><a href="#n100">100</a></p>
<p id="n101" class="pln"><a href="#n101">101</a></p>
<p id="n102" class="pln"><a href="#n102">102</a></p>
<p id="n103" class="pln"><a href="#n103">103</a></p>
<p id="n104" class="pln"><a href="#n104">104</a></p>
<p id="n105" class="pln"><a href="#n105">105</a></p>
<p id="n106" class="pln"><a href="#n106">106</a></p>
<p id="n107" class="pln"><a href="#n107">107</a></p>
<p id="n108" class="pln"><a href="#n108">108</a></p>
<p id="n109" class="pln"><a href="#n109">109</a></p>
<p id="n110" class="pln"><a href="#n110">110</a></p>
<p id="n111" class="pln"><a href="#n111">111</a></p>
<p id="n112" class="pln"><a href="#n112">112</a></p>
<p id="n113" class="pln"><a href="#n113">113</a></p>
<p id="n114" class="pln"><a href="#n114">114</a></p>
<p id="n115" class="pln"><a href="#n115">115</a></p>
<p id="n116" class="pln"><a href="#n116">116</a></p>
<p id="n117" class="pln"><a href="#n117">117</a></p>
<p id="n118" class="pln"><a href="#n118">118</a></p>
<p id="n119" class="pln"><a href="#n119">119</a></p>
<p id="n120" class="pln"><a href="#n120">120</a></p>
<p id="n121" class="pln"><a href="#n121">121</a></p>
<p id="n122" class="pln"><a href="#n122">122</a></p>
<p id="n123" class="pln"><a href="#n123">123</a></p>
<p id="n124" class="pln"><a href="#n124">124</a></p>
<p id="n125" class="pln"><a href="#n125">125</a></p>
<p id="n126" class="pln"><a href="#n126">126</a></p>
<p id="n127" class="pln"><a href="#n127">127</a></p>
<p id="n128" class="pln"><a href="#n128">128</a></p>
<p id="n129" class="pln"><a href="#n129">129</a></p>
<p id="n130" class="pln"><a href="#n130">130</a></p>
<p id="n131" class="pln"><a href="#n131">131</a></p>
<p id="n132" class="pln"><a href="#n132">132</a></p>
<p id="n133" class="pln"><a href="#n133">133</a></p>
<p id="n134" class="pln"><a href="#n134">134</a></p>
<p id="n135" class="pln"><a href="#n135">135</a></p>
<p id="n136" class="pln"><a href="#n136">136</a></p>
<p id="n137" class="pln"><a href="#n137">137</a></p>
<p id="n138" class="pln"><a href="#n138">138</a></p>
<p id="n139" class="pln"><a href="#n139">139</a></p>
<p id="n140" class="stm run hide_run"><a href="#n140">140</a></p>
<p id="n141" class="pln"><a href="#n141">141</a></p>
<p id="n142" class="pln"><a href="#n142">142</a></p>
<p id="n143" class="pln"><a href="#n143">143</a></p>
<p id="n144" class="pln"><a href="#n144">144</a></p>
<p id="n145" class="stm run hide_run"><a href="#n145">145</a></p>
<p id="n146" class="stm mis"><a href="#n146">146</a></p>
<p id="n147" class="pln"><a href="#n147">147</a></p>
<p id="n148" class="stm run hide_run"><a href="#n148">148</a></p>
<p id="n149" class="pln"><a href="#n149">149</a></p>
<p id="n150" class="pln"><a href="#n150">150</a></p>
<p id="n151" class="stm mis"><a href="#n151">151</a></p>
<p id="n152" class="stm mis"><a href="#n152">152</a></p>
<p id="n153" class="stm mis"><a href="#n153">153</a></p>
<p id="n154" class="stm mis"><a href="#n154">154</a></p>
<p id="n155" class="stm mis"><a href="#n155">155</a></p>
<p id="n156" class="pln"><a href="#n156">156</a></p>
<p id="n157" class="stm mis"><a href="#n157">157</a></p>
<p id="n158" class="pln"><a href="#n158">158</a></p>
<p id="n159" class="stm run hide_run"><a href="#n159">159</a></p>
<p id="n160" class="stm mis"><a href="#n160">160</a></p>
<p id="n161" class="stm mis"><a href="#n161">161</a></p>
<p id="n162" class="stm mis"><a href="#n162">162</a></p>
<p id="n163" class="stm mis"><a href="#n163">163</a></p>
<p id="n164" class="pln"><a href="#n164">164</a></p>
<p id="n165" class="stm run hide_run"><a href="#n165">165</a></p>
<p id="n166" class="pln"><a href="#n166">166</a></p>
<p id="n167" class="pln"><a href="#n167">167</a></p>
<p id="n168" class="pln"><a href="#n168">168</a></p>
<p id="n169" class="stm mis"><a href="#n169">169</a></p>
<p id="n170" class="stm mis"><a href="#n170">170</a></p>
<p id="n171" class="stm mis"><a href="#n171">171</a></p>
<p id="n172" class="stm mis"><a href="#n172">172</a></p>
<p id="n173" class="pln"><a href="#n173">173</a></p>
<p id="n174" class="stm mis"><a href="#n174">174</a></p>
<p id="n175" class="pln"><a href="#n175">175</a></p>
<p id="n176" class="stm mis"><a href="#n176">176</a></p>
<p id="n177" class="stm mis"><a href="#n177">177</a></p>
<p id="n178" class="stm mis"><a href="#n178">178</a></p>
<p id="n179" class="pln"><a href="#n179">179</a></p>
<p id="n180" class="stm mis"><a href="#n180">180</a></p>
<p id="n181" class="pln"><a href="#n181">181</a></p>
<p id="n182" class="stm run hide_run"><a href="#n182">182</a></p>
<p id="n183" class="stm mis"><a href="#n183">183</a></p>
<p id="n184" class="pln"><a href="#n184">184</a></p>
<p id="n185" class="stm run hide_run"><a href="#n185">185</a></p>
<p id="n186" class="stm mis"><a href="#n186">186</a></p>
<p id="n187" class="stm mis"><a href="#n187">187</a></p>
<p id="n188" class="stm mis"><a href="#n188">188</a></p>
<p id="n189" class="stm mis"><a href="#n189">189</a></p>
<p id="n190" class="stm mis"><a href="#n190">190</a></p>
<p id="n191" class="stm mis"><a href="#n191">191</a></p>
<p id="n192" class="pln"><a href="#n192">192</a></p>
<p id="n193" class="stm run hide_run"><a href="#n193">193</a></p>
<p id="n194" class="stm mis"><a href="#n194">194</a></p>
<p id="n195" class="stm mis"><a href="#n195">195</a></p>
<p id="n196" class="stm mis"><a href="#n196">196</a></p>
<p id="n197" class="stm mis"><a href="#n197">197</a></p>

            </td>
            <td class="text">
<p id="t1" class="pln"><span class="com"># SECUREAUTH LABS. Copyright 2018 SecureAuth Corporation. All rights reserved.</span><span class="strut">&nbsp;</span></p>
<p id="t2" class="pln"><span class="com">#</span><span class="strut">&nbsp;</span></p>
<p id="t3" class="pln"><span class="com"># This software is provided under under a slightly modified version</span><span class="strut">&nbsp;</span></p>
<p id="t4" class="pln"><span class="com"># of the Apache Software License. See the accompanying LICENSE file</span><span class="strut">&nbsp;</span></p>
<p id="t5" class="pln"><span class="com"># for more information.</span><span class="strut">&nbsp;</span></p>
<p id="t6" class="pln"><span class="com">#</span><span class="strut">&nbsp;</span></p>
<p id="t7" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t8" class="stm run hide_run"><span class="key">from</span> <span class="nam">impacket</span> <span class="key">import</span> <span class="nam">structure</span><span class="strut">&nbsp;</span></p>
<p id="t9" class="stm run hide_run"><span class="key">from</span> <span class="nam">impacket</span><span class="op">.</span><span class="nam">ImpactPacket</span> <span class="key">import</span> <span class="nam">ProtocolPacket</span><span class="strut">&nbsp;</span></p>
<p id="t10" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t11" class="stm run hide_run"><span class="key">class</span> <span class="nam">BootpPacket</span><span class="op">(</span><span class="nam">ProtocolPacket</span><span class="op">,</span> <span class="nam">structure</span><span class="op">.</span><span class="nam">Structure</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t12" class="stm run hide_run">    <span class="nam">commonHdr</span> <span class="op">=</span> <span class="op">(</span><span class="strut">&nbsp;</span></p>
<p id="t13" class="pln">            <span class="op">(</span><span class="str">'op'</span><span class="op">,</span><span class="str">'b'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t14" class="pln">            <span class="op">(</span><span class="str">'htype'</span><span class="op">,</span><span class="str">'b=1'</span><span class="op">)</span><span class="op">,</span>    <span class="com"># 1 = Ether</span><span class="strut">&nbsp;</span></p>
<p id="t15" class="pln">            <span class="op">(</span><span class="str">'hlen'</span><span class="op">,</span><span class="str">'b=len(chaddr)'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t16" class="pln">            <span class="op">(</span><span class="str">'hops'</span><span class="op">,</span><span class="str">'b=0'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t17" class="pln">            <span class="op">(</span><span class="str">'xid'</span><span class="op">,</span><span class="str">'!L=0'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t18" class="pln">            <span class="op">(</span><span class="str">'secs'</span><span class="op">,</span><span class="str">'!H=0'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t19" class="pln">            <span class="op">(</span><span class="str">'flags'</span><span class="op">,</span><span class="str">'!H=0'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t20" class="pln">            <span class="op">(</span><span class="str">'ciaddr'</span><span class="op">,</span><span class="str">'!L=0'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t21" class="pln">            <span class="op">(</span><span class="str">'yiaddr'</span><span class="op">,</span><span class="str">'!L=0'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t22" class="pln">            <span class="op">(</span><span class="str">'siaddr'</span><span class="op">,</span><span class="str">'!L=0'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t23" class="pln">            <span class="op">(</span><span class="str">'giaddr'</span><span class="op">,</span><span class="str">'!L=0'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t24" class="pln">            <span class="op">(</span><span class="str">'_chaddr'</span><span class="op">,</span><span class="str">'16s=chaddr'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t25" class="pln">            <span class="op">(</span><span class="str">'chaddr'</span><span class="op">,</span><span class="str">'_'</span><span class="op">,</span><span class="str">'_chaddr[:hlen]'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t26" class="pln">            <span class="op">(</span><span class="str">'sname'</span><span class="op">,</span><span class="str">'64s=""'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t27" class="pln">            <span class="op">(</span><span class="str">'file'</span><span class="op">,</span><span class="str">'128s=""'</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t28" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t29" class="stm run hide_run">    <span class="key">def</span> <span class="nam">__init__</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">data</span> <span class="op">=</span> <span class="key">None</span><span class="op">,</span> <span class="nam">alignment</span> <span class="op">=</span> <span class="num">0</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t30" class="stm mis">        <span class="nam">structure</span><span class="op">.</span><span class="nam">Structure</span><span class="op">.</span><span class="nam">__init__</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">data</span><span class="op">,</span> <span class="nam">alignment</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t31" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t32" class="stm run hide_run"><span class="key">class</span> <span class="nam">DhcpPacket</span><span class="op">(</span><span class="nam">ProtocolPacket</span><span class="op">,</span> <span class="nam">structure</span><span class="op">.</span><span class="nam">Structure</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t33" class="pln">    <span class="com"># DHCP: https://www.ietf.org/rfc/rfc2131.txt</span><span class="strut">&nbsp;</span></p>
<p id="t34" class="pln">    <span class="com"># DHCP Options: https://www.ietf.org/rfc/rfc1533.txt</span><span class="strut">&nbsp;</span></p>
<p id="t35" class="pln">    <span class="com"># good list of options: http://www.networksorcery.com/enp/protocol/bootp/options.htm</span><span class="strut">&nbsp;</span></p>
<p id="t36" class="stm run hide_run">    <span class="nam">MAGIC_NUMBER</span> <span class="op">=</span> <span class="num">0x63825363</span><span class="strut">&nbsp;</span></p>
<p id="t37" class="stm run hide_run">    <span class="nam">BOOTREQUEST</span> <span class="op">=</span> <span class="num">1</span><span class="strut">&nbsp;</span></p>
<p id="t38" class="stm run hide_run">    <span class="nam">BOOTREPLY</span>   <span class="op">=</span> <span class="num">2</span><span class="strut">&nbsp;</span></p>
<p id="t39" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t40" class="stm run hide_run">    <span class="nam">DHCPDISCOVER</span><span class="op">=</span> <span class="num">1</span><span class="strut">&nbsp;</span></p>
<p id="t41" class="stm run hide_run">    <span class="nam">DHCPOFFER</span>   <span class="op">=</span> <span class="num">2</span><span class="strut">&nbsp;</span></p>
<p id="t42" class="stm run hide_run">    <span class="nam">DHCPREQUEST</span> <span class="op">=</span> <span class="num">3</span><span class="strut">&nbsp;</span></p>
<p id="t43" class="stm run hide_run">    <span class="nam">DHCPDECLINE</span> <span class="op">=</span> <span class="num">4</span><span class="strut">&nbsp;</span></p>
<p id="t44" class="stm run hide_run">    <span class="nam">DHCPACK</span>     <span class="op">=</span> <span class="num">5</span><span class="strut">&nbsp;</span></p>
<p id="t45" class="stm run hide_run">    <span class="nam">DHCPNAK</span>     <span class="op">=</span> <span class="num">6</span><span class="strut">&nbsp;</span></p>
<p id="t46" class="stm run hide_run">    <span class="nam">DHCPRELEASE</span> <span class="op">=</span> <span class="num">7</span><span class="strut">&nbsp;</span></p>
<p id="t47" class="stm run hide_run">    <span class="nam">DHCPINFORM</span>  <span class="op">=</span> <span class="num">8</span><span class="strut">&nbsp;</span></p>
<p id="t48" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t49" class="stm run hide_run">    <span class="nam">options</span> <span class="op">=</span> <span class="op">{</span><span class="strut">&nbsp;</span></p>
<p id="t50" class="pln">        <span class="com"># 3. Vendor Extensions</span><span class="strut">&nbsp;</span></p>
<p id="t51" class="pln">        <span class="str">'pad'</span><span class="op">:</span><span class="op">(</span><span class="num">0</span><span class="op">,</span><span class="str">'_'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t52" class="pln">        <span class="str">'subnet-mask'</span><span class="op">:</span><span class="op">(</span><span class="num">1</span><span class="op">,</span><span class="str">'!L'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t53" class="pln">        <span class="str">'time-offset'</span><span class="op">:</span><span class="op">(</span><span class="num">2</span><span class="op">,</span><span class="str">'!L'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t54" class="pln">        <span class="str">'router'</span><span class="op">:</span><span class="op">(</span><span class="num">3</span><span class="op">,</span><span class="str">'*!L'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t55" class="pln">        <span class="str">'time-server'</span><span class="op">:</span><span class="op">(</span><span class="num">4</span><span class="op">,</span><span class="str">'*!L'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t56" class="pln">        <span class="str">'name-server'</span><span class="op">:</span><span class="op">(</span><span class="num">5</span><span class="op">,</span><span class="str">'*!L'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t57" class="pln">        <span class="str">'domain-name-server'</span><span class="op">:</span><span class="op">(</span><span class="num">6</span><span class="op">,</span><span class="str">'*!L'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t58" class="pln">        <span class="str">'log-server'</span><span class="op">:</span><span class="op">(</span><span class="num">7</span><span class="op">,</span><span class="str">'*!L'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t59" class="pln">        <span class="str">'cookie-server'</span><span class="op">:</span><span class="op">(</span><span class="num">8</span><span class="op">,</span><span class="str">'*!L'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t60" class="pln">        <span class="str">'lpr-server'</span><span class="op">:</span><span class="op">(</span><span class="num">9</span><span class="op">,</span><span class="str">'*!L'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t61" class="pln">        <span class="str">'impress-server'</span><span class="op">:</span><span class="op">(</span><span class="num">10</span><span class="op">,</span><span class="str">'*!L'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t62" class="pln">        <span class="str">'resource-locator-server'</span><span class="op">:</span><span class="op">(</span><span class="num">11</span><span class="op">,</span><span class="str">'*!L'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t63" class="pln">        <span class="str">'host-name'</span><span class="op">:</span><span class="op">(</span><span class="num">12</span><span class="op">,</span><span class="str">':'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t64" class="pln">        <span class="str">'boot-file-size'</span><span class="op">:</span><span class="op">(</span><span class="num">13</span><span class="op">,</span><span class="str">'!H'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t65" class="pln">        <span class="str">'merit-dump-file'</span><span class="op">:</span><span class="op">(</span><span class="num">14</span><span class="op">,</span><span class="str">':'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t66" class="pln">        <span class="str">'domain-name'</span><span class="op">:</span><span class="op">(</span><span class="num">15</span><span class="op">,</span><span class="str">':'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t67" class="pln">        <span class="str">'swap-server'</span><span class="op">:</span><span class="op">(</span><span class="num">16</span><span class="op">,</span><span class="str">':'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t68" class="pln">        <span class="str">'root-path'</span><span class="op">:</span><span class="op">(</span><span class="num">17</span><span class="op">,</span><span class="str">':'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t69" class="pln">        <span class="str">'extensions-path'</span><span class="op">:</span><span class="op">(</span><span class="num">18</span><span class="op">,</span><span class="str">':'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t70" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t71" class="pln">        <span class="com"># 4. IP Layer Parameters per Host</span><span class="strut">&nbsp;</span></p>
<p id="t72" class="pln">        <span class="str">'ip-forwarding'</span><span class="op">:</span><span class="op">(</span><span class="num">19</span><span class="op">,</span><span class="str">'B'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t73" class="pln">        <span class="str">'non-local-source-routing'</span><span class="op">:</span><span class="op">(</span><span class="num">20</span><span class="op">,</span><span class="str">'B'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t74" class="pln">        <span class="str">'policy-filter'</span><span class="op">:</span><span class="op">(</span><span class="num">21</span><span class="op">,</span><span class="str">'*!L'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t75" class="pln">        <span class="str">'maximum-datagram-reassembly-size'</span><span class="op">:</span><span class="op">(</span><span class="num">22</span><span class="op">,</span><span class="str">'!H'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t76" class="pln">        <span class="str">'default-ip-ttl'</span><span class="op">:</span><span class="op">(</span><span class="num">23</span><span class="op">,</span><span class="str">'B'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t77" class="pln">        <span class="str">'path-mtu-aging-timeout'</span><span class="op">:</span><span class="op">(</span><span class="num">24</span><span class="op">,</span><span class="str">'!L'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t78" class="pln">        <span class="str">'path-mtu-plateau-table'</span><span class="op">:</span><span class="op">(</span><span class="num">25</span><span class="op">,</span><span class="str">'*!H'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t79" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t80" class="pln">        <span class="com"># 5. IP Layer Parameters per Interface</span><span class="strut">&nbsp;</span></p>
<p id="t81" class="pln">        <span class="str">'interface-mtu'</span><span class="op">:</span><span class="op">(</span><span class="num">26</span><span class="op">,</span><span class="str">'!H'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t82" class="pln">        <span class="str">'all-subnets-are-local'</span><span class="op">:</span><span class="op">(</span><span class="num">27</span><span class="op">,</span><span class="str">'B'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t83" class="pln">        <span class="str">'broadcast-address'</span><span class="op">:</span><span class="op">(</span><span class="num">28</span><span class="op">,</span><span class="str">'!L'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t84" class="pln">        <span class="str">'perform-mask-discovery'</span><span class="op">:</span><span class="op">(</span><span class="num">29</span><span class="op">,</span><span class="str">'B'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t85" class="pln">        <span class="str">'mask-supplier'</span><span class="op">:</span><span class="op">(</span><span class="num">30</span><span class="op">,</span><span class="str">'B'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t86" class="pln">        <span class="str">'perform-router-discovery'</span><span class="op">:</span><span class="op">(</span><span class="num">31</span><span class="op">,</span><span class="str">'B'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t87" class="pln">        <span class="str">'router-solicitation-address'</span><span class="op">:</span><span class="op">(</span><span class="num">32</span><span class="op">,</span><span class="str">'!L'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t88" class="pln">        <span class="str">'static-route'</span><span class="op">:</span><span class="op">(</span><span class="num">33</span><span class="op">,</span><span class="str">'*!L'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t89" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t90" class="pln">        <span class="com"># 6. Link Layer Parameters per Interface</span><span class="strut">&nbsp;</span></p>
<p id="t91" class="pln">        <span class="str">'trailer-encapsulation'</span><span class="op">:</span><span class="op">(</span><span class="num">34</span><span class="op">,</span><span class="str">'B'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t92" class="pln">        <span class="str">'arp-cache-timeout'</span><span class="op">:</span><span class="op">(</span><span class="num">35</span><span class="op">,</span><span class="str">'!L'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t93" class="pln">        <span class="str">'ethernet-encapsulation'</span><span class="op">:</span><span class="op">(</span><span class="num">36</span><span class="op">,</span><span class="str">'B'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t94" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t95" class="pln">        <span class="com"># 7. TCP parameters</span><span class="strut">&nbsp;</span></p>
<p id="t96" class="pln">        <span class="str">'tcp-default-ttl'</span><span class="op">:</span><span class="op">(</span><span class="num">37</span><span class="op">,</span><span class="str">'B'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t97" class="pln">        <span class="str">'tcp-keepalive-interval'</span><span class="op">:</span><span class="op">(</span><span class="num">38</span><span class="op">,</span><span class="str">'!L'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t98" class="pln">        <span class="str">'tcp-keepalive-garbage'</span><span class="op">:</span><span class="op">(</span><span class="num">39</span><span class="op">,</span><span class="str">'B'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t99" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t100" class="pln">        <span class="com"># 8. Application and Service parameters</span><span class="strut">&nbsp;</span></p>
<p id="t101" class="pln">        <span class="str">'nis-domain'</span><span class="op">:</span><span class="op">(</span><span class="num">40</span><span class="op">,</span><span class="str">':'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t102" class="pln">        <span class="str">'nis-servers'</span><span class="op">:</span><span class="op">(</span><span class="num">41</span><span class="op">,</span><span class="str">'*!L'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t103" class="pln">        <span class="str">'ntp-servers'</span><span class="op">:</span><span class="op">(</span><span class="num">42</span><span class="op">,</span><span class="str">'*!L'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t104" class="pln">        <span class="str">'vendor-specific'</span><span class="op">:</span><span class="op">(</span><span class="num">43</span><span class="op">,</span><span class="str">':'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t105" class="pln">        <span class="str">'netbios-name-server'</span><span class="op">:</span><span class="op">(</span><span class="num">44</span><span class="op">,</span><span class="str">'*!L'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t106" class="pln">        <span class="str">'netbios-datagrame-distribution-server'</span><span class="op">:</span><span class="op">(</span><span class="num">45</span><span class="op">,</span><span class="str">'*!L'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t107" class="pln">        <span class="str">'netbios-node-type'</span><span class="op">:</span><span class="op">(</span><span class="num">46</span><span class="op">,</span><span class="str">'B'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t108" class="pln">        <span class="str">'netbios-scope'</span><span class="op">:</span><span class="op">(</span><span class="num">47</span><span class="op">,</span><span class="str">':'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t109" class="pln">        <span class="str">'x11-font-server'</span><span class="op">:</span><span class="op">(</span><span class="num">48</span><span class="op">,</span><span class="str">'*!L'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t110" class="pln">        <span class="str">'x11-display-manager'</span><span class="op">:</span><span class="op">(</span><span class="num">49</span><span class="op">,</span><span class="str">'*!L'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t111" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t112" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t113" class="pln">        <span class="com"># 9. DHCP Extensions</span><span class="strut">&nbsp;</span></p>
<p id="t114" class="pln">        <span class="str">'requested-ip'</span><span class="op">:</span><span class="op">(</span><span class="num">50</span><span class="op">,</span><span class="str">'!L'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t115" class="pln">        <span class="str">'lease-time'</span><span class="op">:</span><span class="op">(</span><span class="num">51</span><span class="op">,</span><span class="str">'!L'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t116" class="pln">        <span class="str">'option-overload'</span><span class="op">:</span><span class="op">(</span><span class="num">52</span><span class="op">,</span><span class="str">'B'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t117" class="pln">        <span class="str">'message-type'</span><span class="op">:</span><span class="op">(</span><span class="num">53</span><span class="op">,</span><span class="str">'B'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t118" class="pln">        <span class="str">'server-id'</span><span class="op">:</span><span class="op">(</span><span class="num">54</span><span class="op">,</span><span class="str">'!L'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t119" class="pln">        <span class="str">'parameter-request-list'</span><span class="op">:</span><span class="op">(</span><span class="num">55</span><span class="op">,</span><span class="str">':'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t120" class="pln">        <span class="str">'message'</span><span class="op">:</span><span class="op">(</span><span class="num">56</span><span class="op">,</span><span class="str">':'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t121" class="pln">        <span class="str">'maximum-dhcp-message-size'</span><span class="op">:</span><span class="op">(</span><span class="num">57</span><span class="op">,</span><span class="str">'!H'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t122" class="pln">        <span class="str">'renewal-time'</span><span class="op">:</span><span class="op">(</span><span class="num">58</span><span class="op">,</span><span class="str">'!L'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t123" class="pln">        <span class="str">'rebinding-time'</span><span class="op">:</span><span class="op">(</span><span class="num">59</span><span class="op">,</span><span class="str">'!L'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t124" class="pln">        <span class="str">'vendor-class'</span><span class="op">:</span><span class="op">(</span><span class="num">60</span><span class="op">,</span><span class="str">':'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t125" class="pln">        <span class="str">'client-id'</span><span class="op">:</span><span class="op">(</span><span class="num">61</span><span class="op">,</span><span class="str">':'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t126" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t127" class="pln">        <span class="com"># other non-rfc1533 options</span><span class="strut">&nbsp;</span></p>
<p id="t128" class="pln">        <span class="str">'slp-directory-agent'</span><span class="op">:</span><span class="op">(</span><span class="num">78</span><span class="op">,</span><span class="str">':'</span><span class="op">)</span><span class="op">,</span>           <span class="com"># https://www.ietf.org/rfc/rfc2610.txt</span><span class="strut">&nbsp;</span></p>
<p id="t129" class="pln">        <span class="str">'slp-service-scope'</span><span class="op">:</span><span class="op">(</span><span class="num">79</span><span class="op">,</span><span class="str">':'</span><span class="op">)</span><span class="op">,</span>             <span class="com"># https://www.ietf.org/rfc/rfc2610.txt</span><span class="strut">&nbsp;</span></p>
<p id="t130" class="pln">        <span class="str">'fully-qualified-domain-name'</span><span class="op">:</span><span class="op">(</span><span class="num">81</span><span class="op">,</span><span class="str">':'</span><span class="op">)</span><span class="op">,</span>   <span class="com"># https://www.ietf.org/rfc/rfc4702.txt</span><span class="strut">&nbsp;</span></p>
<p id="t131" class="pln">        <span class="str">'default-url'</span><span class="op">:</span> <span class="op">(</span><span class="num">114</span><span class="op">,</span> <span class="str">':'</span><span class="op">)</span><span class="op">,</span>                <span class="com"># text (URL) - not defined in any RFC but assigned by IANA</span><span class="strut">&nbsp;</span></p>
<p id="t132" class="pln">        <span class="str">'auto-configuration'</span><span class="op">:</span><span class="op">(</span><span class="num">116</span><span class="op">,</span><span class="str">'B'</span><span class="op">)</span><span class="op">,</span>           <span class="com"># https://www.ietf.org/rfc/rfc2563.txt</span><span class="strut">&nbsp;</span></p>
<p id="t133" class="pln">        <span class="str">'domain-search-list'</span><span class="op">:</span><span class="op">(</span><span class="num">119</span><span class="op">,</span><span class="str">':'</span><span class="op">)</span><span class="op">,</span>           <span class="com"># https://www.ietf.org/rfc/rfc3397.txt</span><span class="strut">&nbsp;</span></p>
<p id="t134" class="pln">        <span class="str">'classless-route-121'</span><span class="op">:</span><span class="op">(</span><span class="num">121</span><span class="op">,</span> <span class="str">':'</span><span class="op">)</span><span class="op">,</span>         <span class="com"># https://www.ietf.org/rfc/rfc3442.txt</span><span class="strut">&nbsp;</span></p>
<p id="t135" class="pln">        <span class="str">'classless-route-249'</span><span class="op">:</span><span class="op">(</span><span class="num">249</span><span class="op">,</span> <span class="str">':'</span><span class="op">)</span><span class="op">,</span>         <span class="com"># https://web.archive.org/web/20140205135249/support.microsoft.com/kb/121005</span><span class="strut">&nbsp;</span></p>
<p id="t136" class="pln">        <span class="str">'proxy-autoconfig'</span><span class="op">:</span><span class="op">(</span><span class="num">252</span><span class="op">,</span><span class="str">':'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t137" class="pln">        <span class="str">'eof'</span><span class="op">:</span><span class="op">(</span><span class="num">255</span><span class="op">,</span><span class="str">'_'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t138" class="pln">    <span class="op">}</span><span class="strut">&nbsp;</span></p>
<p id="t139" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t140" class="stm run hide_run">    <span class="nam">structure</span> <span class="op">=</span> <span class="op">(</span><span class="strut">&nbsp;</span></p>
<p id="t141" class="pln">            <span class="op">(</span><span class="str">'cookie'</span><span class="op">,</span><span class="str">'!L'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t142" class="pln">            <span class="op">(</span><span class="str">'_options'</span><span class="op">,</span><span class="str">':=self.packOptions(options)'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t143" class="pln">            <span class="op">(</span><span class="str">'options'</span><span class="op">,</span><span class="str">'_'</span><span class="op">,</span><span class="str">'self.unpackOptions(_options)'</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t144" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t145" class="stm run hide_run">    <span class="key">def</span> <span class="nam">__init__</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">data</span> <span class="op">=</span> <span class="key">None</span><span class="op">,</span> <span class="nam">alignment</span> <span class="op">=</span> <span class="num">0</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t146" class="stm mis">        <span class="nam">structure</span><span class="op">.</span><span class="nam">Structure</span><span class="op">.</span><span class="nam">__init__</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">data</span><span class="op">,</span> <span class="nam">alignment</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t147" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t148" class="stm run hide_run">    <span class="key">def</span> <span class="nam">packOptions</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">options</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t149" class="pln">        <span class="com"># options is an array of tuples: ('name',value)</span><span class="strut">&nbsp;</span></p>
<p id="t150" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t151" class="stm mis">        <span class="nam">answer</span> <span class="op">=</span> <span class="str">''</span><span class="strut">&nbsp;</span></p>
<p id="t152" class="stm mis">        <span class="key">for</span> <span class="nam">name</span><span class="op">,</span> <span class="nam">value</span> <span class="key">in</span> <span class="nam">options</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t153" class="stm mis">            <span class="nam">code</span><span class="op">,</span><span class="nam">format</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">options</span><span class="op">[</span><span class="nam">name</span><span class="op">]</span><span class="strut">&nbsp;</span></p>
<p id="t154" class="stm mis">            <span class="nam">val</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">pack</span><span class="op">(</span><span class="nam">format</span><span class="op">,</span> <span class="nam">value</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t155" class="stm mis">            <span class="nam">answer</span> <span class="op">+=</span> <span class="str">'%c%c%s'</span> <span class="op">%</span> <span class="op">(</span><span class="nam">code</span><span class="op">,</span> <span class="nam">len</span><span class="op">(</span><span class="nam">val</span><span class="op">)</span><span class="op">,</span> <span class="nam">val</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t156" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t157" class="stm mis">        <span class="key">return</span> <span class="nam">answer</span><span class="strut">&nbsp;</span></p>
<p id="t158" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t159" class="stm run hide_run">    <span class="key">def</span> <span class="nam">getOptionNameAndFormat</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">optionCode</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t160" class="stm mis">        <span class="key">for</span> <span class="nam">k</span> <span class="key">in</span> <span class="nam">self</span><span class="op">.</span><span class="nam">options</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t161" class="stm mis">            <span class="nam">code</span><span class="op">,</span><span class="nam">format</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">options</span><span class="op">[</span><span class="nam">k</span><span class="op">]</span><span class="strut">&nbsp;</span></p>
<p id="t162" class="stm mis">            <span class="key">if</span> <span class="nam">code</span> <span class="op">==</span> <span class="nam">optionCode</span><span class="op">:</span> <span class="key">return</span> <span class="nam">k</span><span class="op">,</span> <span class="nam">format</span><span class="strut">&nbsp;</span></p>
<p id="t163" class="stm mis">        <span class="key">return</span> <span class="nam">optionCode</span><span class="op">,</span> <span class="str">':'</span><span class="strut">&nbsp;</span></p>
<p id="t164" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t165" class="stm run hide_run">    <span class="key">def</span> <span class="nam">unpackOptions</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">options</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t166" class="pln">        <span class="com"># options is a string</span><span class="strut">&nbsp;</span></p>
<p id="t167" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t168" class="pln">        <span class="com"># print '%r' % options</span><span class="strut">&nbsp;</span></p>
<p id="t169" class="stm mis">        <span class="nam">answer</span> <span class="op">=</span> <span class="op">[</span><span class="op">]</span><span class="strut">&nbsp;</span></p>
<p id="t170" class="stm mis">        <span class="nam">i</span> <span class="op">=</span> <span class="num">0</span><span class="strut">&nbsp;</span></p>
<p id="t171" class="stm mis">        <span class="key">while</span> <span class="nam">i</span> <span class="op">&lt;</span> <span class="nam">len</span><span class="op">(</span><span class="nam">options</span><span class="op">)</span><span class="op">-</span><span class="num">1</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t172" class="stm mis">            <span class="nam">name</span><span class="op">,</span> <span class="nam">format</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">getOptionNameAndFormat</span><span class="op">(</span><span class="nam">ord</span><span class="op">(</span><span class="nam">options</span><span class="op">[</span><span class="nam">i</span><span class="op">]</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t173" class="pln">            <span class="com"># size = self.calcUnpackSize(format, options[i+1:])</span><span class="strut">&nbsp;</span></p>
<p id="t174" class="stm mis">            <span class="nam">size</span> <span class="op">=</span> <span class="nam">ord</span><span class="op">(</span><span class="nam">options</span><span class="op">[</span><span class="nam">i</span><span class="op">+</span><span class="num">1</span><span class="op">]</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t175" class="pln">            <span class="com"># print i, name, format, size</span><span class="strut">&nbsp;</span></p>
<p id="t176" class="stm mis">            <span class="nam">value</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">unpack</span><span class="op">(</span><span class="nam">format</span><span class="op">,</span> <span class="nam">options</span><span class="op">[</span><span class="nam">i</span><span class="op">+</span><span class="num">2</span><span class="op">:</span><span class="nam">i</span><span class="op">+</span><span class="num">2</span><span class="op">+</span><span class="nam">size</span><span class="op">]</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t177" class="stm mis">            <span class="nam">answer</span><span class="op">.</span><span class="nam">append</span><span class="op">(</span><span class="op">(</span><span class="nam">name</span><span class="op">,</span> <span class="nam">value</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t178" class="stm mis">            <span class="nam">i</span> <span class="op">+=</span> <span class="num">2</span><span class="op">+</span><span class="nam">size</span><span class="strut">&nbsp;</span></p>
<p id="t179" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t180" class="stm mis">        <span class="key">return</span> <span class="nam">answer</span><span class="strut">&nbsp;</span></p>
<p id="t181" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t182" class="stm run hide_run">    <span class="key">def</span> <span class="nam">unpackParameterRequestList</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">options</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t183" class="stm mis">        <span class="key">return</span> <span class="op">[</span><span class="nam">self</span><span class="op">.</span><span class="nam">getOptionNameAndFormat</span><span class="op">(</span><span class="nam">ord</span><span class="op">(</span><span class="nam">opt</span><span class="op">)</span><span class="op">)</span><span class="op">[</span><span class="num">0</span><span class="op">]</span> <span class="key">for</span> <span class="nam">opt</span> <span class="key">in</span> <span class="nam">options</span><span class="op">]</span><span class="strut">&nbsp;</span></p>
<p id="t184" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t185" class="stm run hide_run">    <span class="key">def</span> <span class="nam">isAskingForProxyAutodiscovery</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t186" class="stm mis">        <span class="key">for</span> <span class="nam">opt</span> <span class="key">in</span> <span class="nam">self</span><span class="op">.</span><span class="nam">fields</span><span class="op">[</span><span class="str">'options'</span><span class="op">]</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t187" class="stm mis">            <span class="key">if</span> <span class="nam">opt</span><span class="op">[</span><span class="num">0</span><span class="op">]</span> <span class="op">==</span> <span class="str">'parameter-request-list'</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t188" class="stm mis">                <span class="key">for</span> <span class="nam">optCode</span> <span class="key">in</span> <span class="nam">opt</span><span class="op">[</span><span class="num">1</span><span class="op">]</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t189" class="stm mis">                    <span class="key">if</span> <span class="nam">ord</span><span class="op">(</span><span class="nam">optCode</span><span class="op">)</span> <span class="op">==</span> <span class="num">252</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t190" class="stm mis">                        <span class="key">return</span> <span class="key">True</span><span class="strut">&nbsp;</span></p>
<p id="t191" class="stm mis">        <span class="key">return</span> <span class="key">False</span><span class="strut">&nbsp;</span></p>
<p id="t192" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t193" class="stm run hide_run">    <span class="key">def</span> <span class="nam">getOptionValue</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">name</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t194" class="stm mis">        <span class="key">for</span> <span class="nam">opt</span> <span class="key">in</span> <span class="nam">self</span><span class="op">.</span><span class="nam">fields</span><span class="op">[</span><span class="str">'options'</span><span class="op">]</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t195" class="stm mis">            <span class="key">if</span> <span class="nam">opt</span><span class="op">[</span><span class="num">0</span><span class="op">]</span> <span class="op">==</span> <span class="nam">name</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t196" class="stm mis">                <span class="key">return</span> <span class="nam">opt</span><span class="op">[</span><span class="num">1</span><span class="op">]</span><span class="strut">&nbsp;</span></p>
<p id="t197" class="stm mis">        <span class="key">return</span> <span class="key">None</span><span class="strut">&nbsp;</span></p>

            </td>
        </tr>
    </table>
</div>

<div id="footer">
    <div class="content">
        <p>
            <a class="nav" href="index.html">&#xab; index</a> &nbsp; &nbsp; <a class="nav" href="https://coverage.readthedocs.io">coverage.py v4.5.4</a>,
            created at 2019-09-25 12:47
        </p>
    </div>
</div>

</body>
</html>
